// #autoload
// #name = SpeedTach
// #author = Bluez
// #email = Bluez@oldfogieshome.com
// #web = http://www.oldfogieshome.com
// #include = support/events.cs
// #include = support/loadout.cs
// #include = support/mission_callbacks.cs
// #hide

	new GuiControl(Tach) {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 273";
		extent = "100 100";
		minExtent = "100 100";
		visible = "1";

		new HudBitmapCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "12 12";
			extent = "75 76";
			minExtent = "8 8";
			visible = "1";
			opacity = "1";
			bitmap = "gui/panel2";
			autoCenter = "1";
			autoResize = "1";
			flipVertical = "0";
			flipHorizontal = "0";

			new HudBitmapCtrl(SpinnerCTRL) {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "-1 0";
				extent = "75 76";
				minExtent = "8 8";
				visible = "1";
				opacity = "0.9";
				bitmap = "gui/spinner1";
				autoCenter = "1";
				autoResize = "1";
				flipVertical = "0";
				flipHorizontal = "0";
			};
		};
		new HudBitmapCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "12 12";
			extent = "75 76";
			minExtent = "75 76";
			visible = "1";
			opacity = "0.8";
			bitmap = "gui/panel2aoo1.png";
			autoCenter = "1";
			autoResize = "1";
		};
		new GuiTextCtrl(Tachtext) {
			profile = "ShellTextCenterProfile";
			horizSizing = "relative";
			vertSizing = "center";
			position = "52 40";
			extent = "31 22";
			minExtent = "8 8";
			visible = "1";
			longTextBuffer = "0";
			maxLength = "255";
		};
	};
    playgui.add(Tach);

    if (isObject(HM) && isObject(HudMover))
        hudmover::addhud(Tach, "Speed Tach");

$BmpScale[0] = "gui/spinner1";
$BmpScale[1] = "gui/spinner1";
$BmpScale[2] = "gui/spinner2";
$BmpScale[3] = "gui/spinner3";
$BmpScale[4] = "gui/spinner4";
$BmpScale[5] = "gui/spinner5";
$BmpScale[6] = "gui/spinner6";
$BmpScale[7] = "gui/spinner7";
$BmpScale[8] = "gui/spinner8";
$BmpScale[9] = "gui/spinner9";
$BmpScale[10] = "gui/spinner10";
$BmpScale[11] = "gui/spinner11";
$BmpScale[12] = "gui/spinner12";
$BmpScale[13] = "gui/spinner13";
$BmpScale[14] = "gui/spinner14";
$BmpScale[15] = "gui/spinner15";
$BmpScale[16] = "gui/spinner16";
$BmpScale[17] = "gui/spinner17";
$BmpScale[18] = "gui/spinner18";
$BmpScale[19] = "gui/spinner19";
$BmpScale[20] = "gui/spinner20";
$BmpScale[40] = "gui/spinner1";
$BmpScale[39] = "gui/spinner2";
$BmpScale[38] = "gui/spinner3";
$BmpScale[37] = "gui/spinner4";
$BmpScale[36] = "gui/spinner5";
$BmpScale[35] = "gui/spinner6";
$BmpScale[34] = "gui/spinner7";
$BmpScale[33] = "gui/spinner8";
$BmpScale[32] = "gui/spinner9";
$BmpScale[31] = "gui/spinner10";
$BmpScale[30] = "gui/spinner11";
$BmpScale[29] = "gui/spinner12";
$BmpScale[28] = "gui/spinner13";
$BmpScale[27] = "gui/spinner14";
$BmpScale[26] = "gui/spinner15";
$BmpScale[25] = "gui/spinner16";
$BmpScale[24] = "gui/spinner17";
$BmpScale[23] = "gui/spinner18";
$BmpScale[22] = "gui/spinner19";
$BmpScale[21] = "gui/spinner20";

function SpinnerReset() {
         if(isEventPending($SpinnerUpdate))
            cancel($SpinnerUpdate);
}

function SpinnerBMPCTRL() {
         %speed = mFloor(getControlObjectSpeed() * 3.6);
         %speedinc = mfloor((%speed / 400) * 40);

         if (%speedinc > 40) %speedinc = 40;
         
         %step = $BmpScale[%speedinc];
         $VertFlip = (%speedinc > 20) ? 1 : 0;
         
         SpinnerCTRL.flipVertical = $VertFlip;
         SpinnerCTRL.setbitmap(%step);
         Tachtext.setValue(%speed);
         
         if(isEventPending($SpinnerUpdate))
            cancel($SpinnerUpdate);

         $SpinnerUpdate = schedule(50, 0, SpinnerBMPCTRL);
}

callback.add(onGameOver, SpinnerReset);
callback.add(PlayerSpawn, SpinnerBMPCTRL);

